function y = dav(x,M)

// M = valeur abs max de x

getf("energie.sci");

N = length(x);

// Enveloppe determinee a partir de l'energie du signal

T_conf_ct = 20;             // lambda_ct = 0.95
T_conf_ltd = 100;           // lambda_ltd = 0.99
T_conf_ltm = 200;           // lambda_ltm = 0.995  

T_maintien = 1600;          // silence intersyllabique : 200 ms
maintien = T_maintien + 1;  // pour le debut du signal

Ect = zeros(1,N);           // Energie a court terme
Elt = zeros(1,N); 	    // Energie a long terme
seuil = zeros(1,N); 
y = zeros(N,1);

alpha = 2^2;                // Seuil=2*Emoy 

Ect(1) = energie(0,x(1),0,0);           
Elt(1) = energie(0,x(1),0,0);            
seuil(1) = max(alpha*Elt(1), (M/100)^2);
     
for i=2:N
    
  lambda_ct = 1-(1/min(i,T_conf_ct));
  lambda_ltd = 1-(1/min(i,T_conf_ltd));     	 
  lambda_ltm = 1-(1/min(i,T_conf_ltm));     	 
 
  Ect(i) = energie(Ect(i-1),x(i),lambda_ct,lambda_ct);

  if (i>T_conf_ltm) & ((Ect(i)>seuil(i-1)) | (maintien<T_maintien))
       y(i) = 1;  
       if (Ect(i)>seuil(i-1)) 
         maintien = 0;
       else 
         maintien = maintien + 1;
       end
       Elt(i) = Elt(i-1);
       seuil(i) = seuil(i-1);
  else
       Elt(i) = energie(Elt(i-1),x(i),lambda_ltm,lambda_ltd);
       seuil(i) = max(alpha*Elt(i), (M/100)^2);
  end

end // du for
