//opt = 1 pour Q1, 2 pour Q2, 3 pour Q3a et 4 pour Q3b
opt = 1;

if (~exists("DAVs")) then 

  getf("dav.sci");
  // Ouverture du fichier de parole (sans bruit)
  nom = "F1";
  s = wavread(nom+"_ori");
  s = s-mean(s);
  N = length(s);

  // Segmentation parole/silence
  disp("DAV")
  DAVs = dav(s,1);

  // Ajout du bruit
  disp("Ajout du bruit")
  RSB = 20;
  sigma = (sqrt((1/sum(DAVs))*sum((s.*DAVs).^2)))/(10^(RSB/20));
  b = sigma*rand(N,1,"normal");

  x = s + b;
  x = x';

end

// Debruitage
getf("debruite.sci"); 
disp("Debruitage")

x_debruit = debruite(x,DAVs,opt);

// Enregistrement
wavwrite(x',8000,16,nom+"_b");
wavwrite(x_debruit',8000,16,nom+"_deb"+string(opt));

disp("Fini")

