getf("trace_gabarit.sci")

M = 5; L = 2*M+1;
n = -M:M;

// Réponse impulsionnelle de n = -M a +M (L échantillons)
h = 0.5*sinc(n*%pi/2);	

// Affichage de h(n) sur la fenetre 0
xset("window",0); xbasc();
plot2d(n,h,-9)
xtitle("Reponse impulsionnelle h(n)","n","h(n)");

// Réponse fréquentielle de h tronque' et décalé de 5 échantillons
NFFT = 512;	// nombre d'echantillons de la TFD
h_zeropadding = [h,zeros(1,NFFT-L)];
H = fft(h_zeropadding,-1);	// H(f) pour f de 0 à 1 (avec NFFT echantillons frequentiels)

// Affichage de |H(f)| sur la fenetre 1
H = fftshift(H);	// H(f) pour f de -1/2 à +1/2
f = -0.5:1/NFFT:0.5-1/NFFT;	// frequences normalisees : NFFT echantillons frequentiels
xset("window",1); xbasc();
plot2d(f,20*log10(abs(H)),2,"011","",[-0.5 -50 0.5 5])
xtitle("Reponse frequentielle (en dB)","f","|H(f)| (dB)")
// trace_gabarit(frequence de coupure, largeur de la bande de transition, attenuation en valeur lineaire (pas en dB), ordonnee minimale de la figure); 	

